#include "isp3.h"

// int error=0;
// int pmode=0;
int here; // address for reading and writing, set by 'U' command
int pagesize;
int eepromsize;
//RingBuff_t TX_Buffer;
//RingBuff_t RX_Buffer;

/*
int main(void) {
  SetupHardware();

	RingBuffer_InitBuffer(&TX_Buffer);
	RingBuffer_InitBuffer(&RX_Buffer);

	sei();

  for (;;) {
    if ( !(RingBuffer_IsEmpty(&TX_Buffer)) )   send( RingBuffer_Remove(&TX_Buffer) ); // read outgoing buffer
    if ( !(RingBuffer_IsEmpty(&RX_Buffer)) ) avrisp( RingBuffer_Remove(&RX_Buffer) ); // read incomming buffer (1/2)
  }
}

void SetupHardware(void) {
	// Disable watchdog if enabled by bootloader/fuses
	MCUSR &= ~(1 << WDRF);
	wdt_disable();

  // Serial init
  // USART0 in ATmega328:
  UBRR0L = 103; //19200 baud
  UCSR0A |= (1<<U2X0);
  UCSR0B |= (1<<RXCIE0) | (1<<RXEN0) | (1<<TXEN0);
  // USART1 in ATmega8U2:
  //UBRR1L = 103; //19200 baud
  //UCSR1A |= (1<<U2X1);
  //UCSR1B |= (1<<RXCIE1) | (1<<RXEN1) | (1<<TXEN1);
  
  // Timer init
	TCCR0B = (1 << CS01) | (1 << CS00); // clk-div=64 (overflow every 1ms)
}

void send(uint8_t ch) {
  // USART0 in ATmega328:
  while ( !( UCSR0A & (1<<UDRE0)) ); // Wait for empty transmit buffer
  UDR0 = ch;
  // USART1 in ATmega8U2:
  //while ( !( UCSR1A & (1<<UDRE1)) ); // Wait for empty transmit buffer
  //UDR1 = ch;
}

// USART0 in ATmega328:
ISR(USART_RX_vect) { // write incomming buffer
  uint8_t ReceivedByte = UDR0;
  RingBuffer_Insert(&RX_Buffer, ReceivedByte);
}
// USART1 in ATmega8U2:
//ISR(USART1_RX_vect, ISR_BLOCK) { // write incomming buffer
//  uint8_t ReceivedByte = UDR1;
//  RingBuffer_Insert(&RX_Buffer, ReceivedByte);
//}
*/

/* 
Insert calls to usb_service() whenever avrisp waits or does long loops, in:
  getch()
  fill()
  delay()
  spi_transaction()
*/

uint8_t getch(void) { // read incomming buffer
  uint8_t t=0;
  cli(); time_isp=0; sei();
  // wait
  for (;;) {
    service_usb();    
    if ( !RingBuffer_IsEmpty_l(&USBtoUSART_Buffer) ) {break;}
    cli(); if (time_isp > 100) { t++; time_isp=0; } sei();
    if ( t>TIMEOUT_ISP ) { return 0; }
  }
  return RingBuffer_Remove_l(&USBtoUSART_Buffer);
}

void putch(uint8_t ch) { // write outgoing buffer
  if (USB_DeviceState == DEVICE_STATE_Configured) {
    RingBuffer_Insert_s(&USARTtoUSB_Buffer, ch);
  }
}

void fill(int n) { // fill incomming buffer
  uint8_t t=0;
  cli(); time_isp=0; sei();
  // wait
  for (;;) {
    service_usb();    
    if ( RingBuffer_GetCount_l(&USBtoUSART_Buffer) >= n ) {break;}
    cli(); if (time_isp > 100) { t++; time_isp=0; } sei();
    if ( t>TIMEOUT_ISP ) { return; }
  }
}

void delay(uint8_t t) { // (t)<(actual_delay)<(t+1)
  cli(); time_isp=0; sei();
  for (;;) {
    service_usb();
    cli(); if (time_isp > t) { sei(); break; } sei();
  }
}

void spi_init() {
  uint8_t x;
  PORTB |=  (1<<SS);
  DDRB  |=  (1<<SS); // SS must be high, or an output, for SPI master operation
  //SPCR = 0x53;
  SPCR = ( (1<<SPE) | (1<<MSTR) | (1<<SPR1) | (1<<SPR0) ); // SCK = FCPU/128
  x=SPSR;
  x=SPDR;
}

void spi_wait() {
  // 8 bits * 128 clock cycles = 64us
  do {
  } 
  while (!(SPSR & (1 << SPIF)));
}

uint8_t spi_send(uint8_t b) {
  uint8_t reply;
  SPDR=b;
  spi_wait();
  reply = SPDR;
  return reply;
}

uint8_t spi_transaction(uint8_t a, uint8_t b, uint8_t c, uint8_t d) {
  service_usb();
//  uint8_t n;
  spi_send(a); 
  spi_send(b);
  //if (n != a) error = -1;
  spi_send(c);
  return spi_send(d);
}

void empty_reply() {
  if (CRC_EOP == getch()) {
    putch(STK_INSYNC);
    putch(STK_OK);
  } 
  else {
    // error++;
    putch(STK_NOSYNC);
  }
}

void breply(uint8_t b) {
  if (CRC_EOP == getch()) {
    putch(STK_INSYNC);
    putch(b);
    putch(STK_OK);
  } 
  else {
    // error++;
    putch(STK_NOSYNC);
  }
}

void get_version(uint8_t c) {
  int free=freeMemory();
  switch(c) {
  case 0x80:
    breply(HWVER);
    break;
  case 0x81:
    breply(SWMAJ);
    //breply((free >> 8) & 0xFF); // don't do this : subsequent avrdude behaviour depends on major software number!!!
    break;
  case 0x82:
    //breply(SWMIN);
    breply(free & 0xFF); // mis-use minor software number to report free memory
    break;
  case 0x93:
    breply('S'); // serial programmer
    break;
  default:
    breply(0);
  }
}

void set_parameters() {
  /*
  Read 20 byte packet:
  - following are 8 bits
  devicecode = buff[0]
  revision   = buff[1]
  progtype   = buff[2]
  parmode    = buff[3]
  polling    = buff[4]
  selftimed  = buff[5]
  lockbytes  = buff[6]
  fusebytes  = buff[7]
  flashpoll  = buff[8] 
  ignore buff[9] (= buff[8])
  - following are 16 bits (big endian)
  eeprompoll = buff[10] * 0x0100 + buff[11]
  pagesize   = buff[12] * 0x0100 + buff[13]
  eepromsize = buff[14] * 0x0100 + buff[15]
  - following are 32 bits (big endian)
  flashsize  = buff[16] * 0x01000000 + buff[17] * 0x00010000 + buff[18] * 0x00000100 + buff[19]
  */
  for (uint8_t x = 0; x < 12; x++) getch();
  pagesize   = getch(); pagesize   *= 256; pagesize   += getch();
  eepromsize = getch(); eepromsize *= 256; eepromsize += getch();
  for (uint8_t x = 0; x <  4; x++) getch();
}

void start_pmode() {
  spi_init();
  PORTB |=  (1<<RESET);
  PORTB &= ~(1<<SCK);
  DDRB  |=  ( (1<<RESET) | (1<<SCK) );
  // RESET = HIGH OUTPUT
  delay(50);
  PORTB &= ~(1<<RESET);
  // RESET = LOW OUTPUT
  delay(50);
  DDRB  &= ~(1<<MISO);
  DDRB  |=  (1<<MOSI);
  spi_transaction(0xAC, 0x53, 0x00, 0x00);
  // pmode = 1;
}

void end_pmode() {
  DDRB  &=  ~( (1<<RESET) | (1<<SCK) | (1<<MOSI) | (1<<MISO) | (1<<SS) );
  // RESET = INPUT (no pull-up)
  // pmode = 0;
}

void universal() {
  //int w;
  //uint8_t ch;
  fill(4);
  breply( spi_transaction(getch(),getch(),getch(),getch()) );
}

void flash(uint8_t hilo, int addr, uint8_t data) {
  spi_transaction(0x40+8*hilo, (addr >> 8) & 0xFF, addr & 0xFF, data);
}

void commit(int addr) {
  spi_transaction(0x4C, (addr >> 8) & 0xFF, addr & 0xFF, 0);
}

int current_page(int addr) {
  if (pagesize == 32)  return here & 0xFFFFFFF0;
  if (pagesize == 64)  return here & 0xFFFFFFE0;
  if (pagesize == 128) return here & 0xFFFFFFC0;
  if (pagesize == 256) return here & 0xFFFFFF80;
  return here;
}

void write_flash(int length) {
  // original code checks for EOP before writing flash, but that makes buffering awkward
  fill(length);
  uint8_t result = write_flash_pages(length);
  if (CRC_EOP == getch()) {
    putch(STK_INSYNC);
    putch(result);
  } 
  else {
    // error++;
    putch(STK_NOSYNC);
  }
}

uint8_t write_flash_pages(int length) {
  int page = current_page(here);
  while (length) {
    if (page != current_page(here)) {
      commit(page);
      page = current_page(here);
    }
    flash(LOW, here, getch()); length--;
    flash(HIGH, here, getch()); length--;
    here++;
  }

  commit(page);

  return STK_OK;
}

uint8_t write_eeprom(int length) {
  // here is a word address, get the byte address
  int start = here * 2;
  //int remaining = length;
  if (length > eepromsize) {
    // error++;
    return STK_FAILED;
  }
  while (length > EECHUNK) {
    write_eeprom_chunk(start, EECHUNK);
    start += EECHUNK;
    length -= EECHUNK;
  }
  write_eeprom_chunk(start, length);
  return STK_OK;
}

// write (length) bytes, (start) is a byte address
uint8_t write_eeprom_chunk(int addr, int length) {
  // this writes byte-by-byte,
  // page writing may be faster (4 bytes at a time)
  fill(length);
  //prog_lamp(LOW);
  //for (int x = 0; x < length; x++) {
  while (length--) {
    //start++;
    //int addr = start+x;
    spi_transaction(0xC0, (addr>>8) & 0xFF, addr & 0xFF, getch());
    addr++;
    delay(45);
  }
  //prog_lamp(HIGH); 
  return STK_OK;
}

void program_page() {
  // uint8_t result = (uint8_t) STK_FAILED;
  int length = 256 * getch();
  length += getch();
  uint8_t memtype = getch();
  // flash memory @here, (length) bytes
  if (memtype == 'F') {
    write_flash(length);
    return;
  }
  if (memtype == 'E') {
    uint8_t result = (uint8_t)write_eeprom(length);
    if (CRC_EOP == getch()) {
      putch(STK_INSYNC);
      putch(result);
    } 
    else {
      // error++;
      putch(STK_NOSYNC);
    }
    return;
  }
  putch(STK_FAILED);
  return;
}

uint8_t flash_read(uint8_t hilo, int addr) {
  return spi_transaction(0x20 + hilo * 8,
  (addr >> 8) & 0xFF,
  addr & 0xFF,
  0);
}

uint8_t flash_read_page(int length) {
  // for (int x = 0; x < length; x+=2) {
  while (length) {
    // uint8_t low = flash_read(LOW, here);
    // putch(low);
    // uint8_t high = flash_read(HIGH, here);
    // putch(high);
    putch( flash_read(LOW,  here) );
    putch( flash_read(HIGH, here) );
    here++;
    length-=2;
  }
  return STK_OK;
}

uint8_t eeprom_read_page(int length) {
  // here again we have a word address
  // int start = here * 2;
  int addr = here * 2;
  // for (int x = 0; x < length; x++) {
  while (length) {
    //int addr = start + x;
    putch( spi_transaction(0xA0, (addr >> 8) & 0xFF, addr & 0xFF, 0xFF) );
    addr++;
  }
  return STK_OK;
}

void read_page() {
  int length = 256 * getch();
  length += getch();
  uint8_t memtype = getch();
  if (CRC_EOP != getch()) {
    // error++;
    putch(STK_NOSYNC);
    return;
  }
  putch(STK_INSYNC);
  
  uint8_t result = (uint8_t)STK_FAILED;
  if (memtype == 'F') result = flash_read_page(length);
  if (memtype == 'E') result = eeprom_read_page(length);
  putch(result);
  return;
}

void read_signature() {
  if (CRC_EOP != getch()) {
    // error++;
    putch(STK_NOSYNC);
    return;
  }
  putch(STK_INSYNC);
  /*
  uint8_t high = spi_transaction(0x30, 0x00, 0x00, 0x00);
  putch(high);
  uint8_t middle = spi_transaction(0x30, 0x00, 0x01, 0x00);
  putch(middle);
  uint8_t low = spi_transaction(0x30, 0x00, 0x02, 0x00);
  putch(low);
  */
  putch( spi_transaction(0x30, 0x00, 0x00, 0x00) );
  putch( spi_transaction(0x30, 0x00, 0x01, 0x00) );
  putch( spi_transaction(0x30, 0x00, 0x02, 0x00) );
  putch(STK_OK);
}

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

void avrisp(void) {
  uint8_t ch=getch();
  switch (ch) {
  
  case '0': // 0x30 GET_SYNC
    // error = 0;
    empty_reply();
    break;
    
  case '1': // 0x31 GET_SIGN_ON
    if (getch() == CRC_EOP) {
      putch(STK_INSYNC);
      putch('A');
      putch('V');
      putch('R');
      putch(' ');
      putch('I');
      putch('S');
      putch('P');
      putch(STK_OK);
    }
    break;
    
  case 'A': // 0x41 GET_PARAMETER
    get_version(getch());
    break;
    
  case 'B': // 0x42 SET_DEVICE
    set_parameters();
    empty_reply();
    break;
    
  case 'E': // 0x45 SET_DEVICE_EXT
    getch();
    getch();
    getch();
    getch();
    getch();
    empty_reply();
    break;

  case 'P': // 0x50 ENTER_PROGMODE
    start_pmode();
    empty_reply();
    break;
    
  case 'Q': // 0x51 LEAVE_PROGMODE
    // error=0;
    end_pmode();
    empty_reply();
    break;

  case 'U': // 0x55 LOAD_ADDRESS
    here = getch();
    here += 256 * getch();
    empty_reply();
    break;

  case 'V': // 0x56 UNIVERSAL
    universal();
    break;

  case 0x60: // 0x60 PROG_FLASH
    getch();
    getch();
    empty_reply();
    break;
    
  case 'a': // 0x61 PROG_DATA
    getch();
    empty_reply();
    break;

  case 'd': // 0x64 PROG_PAGE
    program_page();
    break;

  case 't': // 0x74 READ_PAGE
    read_page();    
    break;

  case 'u': // 0x75 READ_SIGN
    read_signature();
    break;

    // expecting a command, not CRC_EOP
    // this is how we can get back in sync
  case CRC_EOP:
    // error++;
    putch(STK_NOSYNC);
    break;

    // anything else we will return STK_UNKNOWN
  default:
    // error++;
    if (CRC_EOP == getch()) 
      putch(STK_UNKNOWN);
    else
      putch(STK_NOSYNC);
  }
}

