//#include <avr/interrupt.h>
//#include <avr/wdt.h>
//#include <avr/io.h>
//#include "LightweightRingBuff.h"
#include "memoryFree.c"

// SPI pins (port B)
#define MOSI   2
#define MISO   3
#define SCK    1
#define SS     0
// Header pins (port B)
#define RESET         7 // TL
#define JUMPER_DEBUG  5 // TR
#define JUMPER_SENSE  6 // BL
#define JUMPER_GND    4 // BR

// Version numbers
#define HWVER 2
#define SWMAJ 1
#define SWMIN 19

// STK Definitions
#define STK_OK      0x10
#define STK_FAILED  0x11
#define STK_UNKNOWN 0x12
#define STK_INSYNC  0x14
#define STK_NOSYNC  0x15
#define CRC_EOP     0x20

#define HIGH 0x1
#define LOW  0x0

#define EECHUNK (32)

#define TIMEOUT_ISP 20

//int main(void);
//void SetupHardware(void);
//void send(uint8_t ch);
uint8_t getch(void);
void putch(uint8_t ch);
void fill(int n);
void delay(uint8_t t);
void spi_init(void);
void spi_wait(void);
uint8_t spi_send(uint8_t b);
uint8_t spi_transaction(uint8_t a, uint8_t b, uint8_t c, uint8_t d);
void empty_reply(void);
void breply(uint8_t b);
void get_version(uint8_t c);
void set_parameters(void);
void start_pmode(void);
void end_pmode(void);
void universal(void);
void flash(uint8_t hilo, int addr, uint8_t data);
void commit(int addr);
int current_page(int addr);
void write_flash(int length);
uint8_t write_flash_pages(int length);
uint8_t write_eeprom(int length);
uint8_t write_eeprom_chunk(int start, int length);
void program_page(void);
uint8_t flash_read(uint8_t hilo, int addr);
uint8_t flash_read_page(int length);
uint8_t eeprom_read_page(int length);
void read_page(void);
void read_signature(void);
void avrisp(void);
